# This tests fsincos on i386

.include "../common/syscalls.i386"

	.globl _start	
_start:	

	#####################################
	# test glibc __sincos routine with 0
	#####################################

	fldl	      zero

	call	      __sincos

	#####################################
	# test glibc __sincos routine with pi
	#####################################

	fldl          pi

	call	      __sincos

	#######################################
	# test glibc __sincos routine with 2*pi
	#######################################
	
	fldl         twopi

	call	      __sincos


	#######################################
	# test glibc __sincos routine with pi/2
	#######################################

        fldl          pi_over_two	

	call	      __sincos

	
	#######################################
	# test glibc __sincos routine with pi/4
	#######################################

	fldl          pi_over_four	
	call	      __sincos

	jmp	our_exit


__sincos:
#	fsincos 			 # sin in ST(0), cos pushed on stack
   	ret			 	 # return



our_exit:

	# fall through to exit

.include "../common/library.i386"

.data

sinout: .int 0xcafecafe,0xbabebabe
cosout:	.int 0xbeefcafe,0x88888888
zero:	.int 0,0
pi:	.int 0x54442d18,0x400921fb
twopi:	.int 0x54442d18,0x401921fb
pi_over_two:  .int 0x54442d18,0x3ff921fb
pi_over_four: .int 0x54442d18,0x3fe921fb
