# This tests fsincos on x86_64

.include "../common/syscalls.x86_64"

	.globl _start	
_start:	

	#####################################
	# test glibc __sincos routine with 0
	#####################################

	mov	      $cosout,%rsi
	mov	      $sinout,%rdi
	mov	      $0,%rax 	  	# load 0
	cvtsi2sd      %rax,%xmm0	# convert to fp	

	call	      __sincos

	#####################################
	# test glibc __sincos routine with pi
	#####################################

	mov	      $cosout,%rsi
	mov	      $sinout,%rdi
	
	mov	      $0x400921fb54442d18,%rax	# pi
	movq          %rax,%xmm0	

	call	      __sincos

	#######################################
	# test glibc __sincos routine with 2*pi
	#######################################

	mov	      $cosout,%rsi
	mov	      $sinout,%rdi
	
	mov	      $0x401921fb54442d18,%rax	# 2pi
	movq          %rax,%xmm0	

	call	      __sincos


	#######################################
	# test glibc __sincos routine with pi/2
	#######################################

	mov	      $cosout,%rsi
	mov	      $sinout,%rdi
	
	mov	      $0x3ff921fb54442d18,%rax	# pi/2
	movq          %rax,%xmm0	

	call	      __sincos

	
	#######################################
	# test glibc __sincos routine with pi/4
	#######################################

	mov	      $cosout,%rsi
	mov	      $sinout,%rdi
	
	mov	      $0x3fe921fb54442d18,%rax	# pi/4
	movq          %rax,%xmm0	

	call	      __sincos


	jmp	our_exit


__sincos:
	movsd  %xmm0,-0x8(%rsp)		 # save value to stack
	fldl   -0x8(%rsp)		 # load it into ST(0)
	fsincos 			 # sin in ST(0), cos pushed on stack
   	ret			 	  # return



our_exit:

	# fall through to exit

.include "../common/library.x86_64"

.data

sinout: .int 0xcafecafe,0xbabebabe
cosout:	.int 0xbeefcafe,0x88888888

