# uldl.s by Vince Weaver
# This shows a bug with Qemu in handling of the extlh instruction
#  assemble with     "as -o uldl.o uldl.s"
#  link with         "ld -o uldl uldl.o"



# syscall numbers

.equ SYSCALL_EXIT,1	
.equ SYSCALL_WRITE,4
		
.equ STDIN,0
.equ STDOUT,1
.equ STDERR,2	
	
	
	.globl _start
_start:
	
	br      $27,0           # fake branch, to grab the location
	                        # of our entry point
	ldgp    $gp,0($27)      # load the GP proper for our entry point
				# this does automagic stuff...
				# gp is used for 64-bit jumps and constants
				# so if you use "la" and the like it will
				# load from gp for you. 
	

	lda     $17,title	  # load title
	br	$26,write_stdout  # print it
	
	lda	$17,test_string	  # load test string
	br	$26,write_stdout  # print it

	ldq	$13,0($17)

	stq	$13,eight_bytes	  # point $13 to our 32-bit wide
				  # test location
				  
	lda	$17,eight_bytes	  # point to it
	br	$26,write_stdout  # print 4 chars

	clr	$11	  # load in a 0
	
load_loop:

	extlh	$13,$11,$12
	
	stq	$12,eight_bytes

	lda	$17,eight_bytes	  # point to it
	br	$26,write_eight   # print 4 chars	
	
        addq    $11,1,$11
	
	cmpeq   $11,8,$1
	beq     $1,load_loop
			

	#================================
	# Exit
	#================================
exit:		
        clr	$16			# 0 exit value
        mov	SYSCALL_EXIT,$0		# put the exit syscall number in v0
        callsys				# and exit
	
	#================================
	# WRITE_STDOUT
	#================================
	# $17 has string
	# $1 is trashed
	
write_stdout:	
	ldil	$0,SYSCALL_WRITE	# Write syscall in $0
	ldil	$16,STDOUT		# 1 in $16 (stdout)
	clr	$18			# 0 (count) in $18
	
str_loop1:
	addq	$17,$18,$1		# offset in $1
	ldbu    $1,0($1)		# load byte
	addq	$18,1,$18		# increment pointer
	bne	$1,str_loop1		# if not nul, repeat
	
	subq	$18,1,$18		# correct count
	callsys				# Make syscall
	
	ret	$26			# return
	
	#================================
	# WRITE_EIGHT
	#================================
	# $17 has string

	
write_eight:	
	ldil	$0,SYSCALL_WRITE	# Write syscall in $0
	
	ldil	$18,0			# 0 (count) in $18	
str_loop2:
	addq	$17,$18,$1		# offset in $1
	ldbu    $16,0($1)		# load byte
	bne	$16,ahead

	ldil	$16,'*'
	stb	$16,0($1)	
ahead:	
	addq	$18,1,$18		# increment pointer
	cmpeq	$18,8,$1
	beq	$1,str_loop2	
		
	ldil	$18,9			# 0 (count) in $18	
	ldil	$16,STDOUT		# 1 in $16 (stdout)
	callsys				# Make syscall
	
	ret	$26			# return	
			
.data

.align 3

eight_bytes: .ascii "HGFEDCBA\n\0"
.align 3
title:	.ascii "EXTLH Test\n\0"
linefeed: .ascii "\n\0"
.align 3
test_string:  .ascii "0123456789abcdefgh\0"
