.include "../common/syscalls.i386"

.equ TEST_SIZE, 64*1024*1024	  	# 64M

	.globl _start	
_start:	

	# run mmap() of 64MB value

	mov	$SYSCALL_MMAP2,%eax     # syscall number
	mov	$0,%ebx		   	# address
	mov	$TEST_SIZE,%ecx		# size = 64M
	mov	$(PROT_READ | PROT_WRITE), %edx
			      		# prot
	mov	$(MAP_PRIVATE | MAP_ANONYMOUS), %esi
					# flags
	mov	$-1,%edi				
					# fd
	mov	$0,%ebp				
					# pgoffset
	int	$0x80

	push	%eax 			# save the address

	mov	%eax,%edi		# point dest to mmap'd region
	mov	$TEST_SIZE,%ecx		# load in size
	xor	%eax,%eax		# clear eax
write_loop:
	inc	%eax			# increment eax
	stosb				# store the byte to mem
	loop	write_loop		# fill mem
	
	pop	%eax			# restore address
	
	push	%eax			# and save it again
	mov	%eax,%esi		# point source to address
	
	mov	$TEST_SIZE,%ecx		# size to go through
	
	xor	%edx,%edx		# clear edx
	xor	%eax,%eax		# clear eax
read_loop:
	lodsb				# load a byte
	add  	%eax,%edx		# add up value
	loop	read_loop	
	
#	mov	%edx,%eax
#	call	print_hex	
#	call	print_lf

	cmp	$0xfe000000,%edx
	je	munmap
	
	mov	$memory_error,%ecx
	call	write_stdout
	
	jmp	exit

munmap:

	# run munmap()

	mov	$SYSCALL_MUNMAP,%eax
	pop	%ebx		    	# restore address
	mov	$TEST_SIZE,%ecx	    	# size
	int	$0x80

	cmp	$0,%eax
	je	munmap_good

	mov	$munmap_error,%ecx
	jmp	munmap_print
	
munmap_good:
	mov	$munmap_ok,%ecx
munmap_print:	
	call	write_stdout

done:

	# fall through to exit

.include "../common/library.i386"

.data

memory_error:	.ascii	"memory alloc error\n\0"
munmap_ok:	.ascii  "munmap(): OK\n\0"
munmap_error:   .ascii  "munmap(): ERROR\n\0"

