# Sycscalls
.equ SYSCALL_EXIT,    60

.text
	
	.globl _start	
_start:	


	mov	$100000,%ecx
looper:
	push	%ax		# push ax
	push	%bx		# push 16-bit reg
	push	%eax		# push eax
	push	%ebx		# push 32-bit reg
	pushw	int_value	# push 16-bit memory value
	pushl	int_value	# push 32-bit memory value
	push	$0xca		# push 8-bit immediate
	push	$0xcafe		# push 16-bit immediate
	push	$0xcafebabe	# push 32-bit immediate

	push	%cs		# push code segment
	push	%ds		# push data segment
	push	%es		# push extra segment
	push	%fs		# push fs
	push	%gs		# push gs
	push	%ss		# push stack segment

	pusha			# push all registers on stack
	popa			# pop all registers off stack

	pushal			# push all 32-bit regs on stack
	popal			# pop all 32-bit regs off stack

# valgrind can't handle:		
	#pushaw			# push all 16-bit regs on stack
	#popaw			# pop all 16-bit regs off stack
	
	pop	%eax		# pop stack segment
	pop	%eax		# pop gs segment
	pop	%eax		# pop fs segment
	pop	%eax		# pop extra segment
	pop	%eax		# pop data segment
	pop	%eax		# pop code segment
				
		
	
	pop	%eax		# pop 32-bit immediate
	pop	%eax		# pop 16-bit immediate
	pop	%eax		# pop 8-bit immediate	
	pop	%eax		# pop 16-bit mem value
	pop	%ax		# pop 32-bit mem value
	pop	%ebx		# pop 32-bit reg
	pop	%eax		# pop eax
	pop	%bx		# pop 16-bit reg
	pop	%ax		# pop ax


	
	loop	looper

        #================================
	# Exit
	#================================
exit:
	push	$1		# Put exit syscall in rax
	pop	%eax

	xor	%ebx,%ebx		# Make return value $0
	int	$(0x80)	
	
	
#===========================================================================
#	section .data
#===========================================================================
.data
int_value:	.int	0xdeadbeef
		
#============================================================================
#	section .bss
#============================================================================
.bss

#.align 32768			# align to a 32kB boundary
.lcomm  out_buffer,262144	# 256kB
