.include "../common/syscalls.alpha"


# linux-2.6.29/arch/alpha/include/asm/stat.h
#struct stat {
#0   unsigned int    st_dev;
#4   unsigned int    st_ino;
#8   unsigned int    st_mode;
#12  unsigned int    st_nlink;
#16  unsigned int    st_uid;
#20  unsigned int    st_gid;
#24  unsigned int    st_rdev;
#32  long     	     st_size;
#40  unsigned long   st_atime;
#48  unsigned long   st_mtime;
#56  unsigned long   st_ctime;
#64  unsigned int    st_blksize;
#68  unsigned int    st_blocks;
#72  unsigned int    st_flags;
#76  unsigned int    st_gen;
#80
#}						
#/* The stat64 structure increases the size of dev_t, blkcnt_t, adds
#   nanosecond resolution times, and padding for expansion.  */
#   
#struct stat64 {
#0   unsigned long   st_dev;
#8   unsigned long   st_ino;
#16   unsigned long   st_rdev;
#24   long            st_size;
#32   unsigned long   st_blocks;
#					   
#40   unsigned int    st_mode;
#44   unsigned int    st_uid;
#48   unsigned int    st_gid;
#52   unsigned int    st_blksize;
#56   unsigned int    st_nlink;
#60   unsigned int    __pad0;
#			
#64   unsigned long   st_atime;
#72   unsigned long   st_atime_nsec;
#80   unsigned long   st_mtime;
#88   unsigned long   st_mtime_nsec;
#96   unsigned long   st_ctime;
#104  unsigned long   st_ctime_nsec;
#112  long            __unused[3];
#136
#};
		

	.globl _start	
_start:	
        br      $27,0           # get location of entry point
	ldgp    $gp,0($27)      # load the GP proper for our entry point

       # run stat
run_stat:       
        ldil    $0,SYSCALL_STAT
	lda     $16,test_file
	lda     $17,stat_buf
	callsys

	lda     $17,stat
	br      $26,write_stdout

	lda     $16,test_file
	br      $26,print_stat
        br      $26,print_lf

	# run fstat
run_fstat:	
	ldil    $0,SYSCALL_OPEN
	lda	$16,test_file
	ldil	$17,O_RDONLY
	callsys
	
	# return in $0?

	mov	$0,$16
	ldil	$0,SYSCALL_FSTAT
	lda	$17,stat_buf
	callsys
	
	ldil	$0,SYSCALL_CLOSE
	callsys

	lda     $17,fstat
	br      $26,write_stdout

	lda     $16,test_file
	br      $26,print_stat
        br      $26,print_lf

       # run stat64
       
        ldil    $0,SYSCALL_STAT64
	lda     $16,test_file
	lda     $17,stat_buf
	callsys
				       
	lda     $17,stat64
	br      $26,write_stdout

	lda     $16,test_file
	br      $26,print_stat64
        br      $26,print_lf

	# test stat on invalid file
#
#	mov	$SYSCALL_STAT,%rax
#	mov	$fake_file,%rdi
#	mov	$stat_buf,%rsi
#	syscall

#	cmp	$0,%rax
#	jge	wrong_answer
	
#	mov	$correct,%rcx
 #       call	write_stdout
#	call	print_lf
	
	
wrong_answer:

	br	our_exit


	#=================
	# print stat struct
	#=================

print_stat:

	# Print filename
	
	mov	$16,$17
	mov	$26,$27
	
	br	$26,write_stdout

	br	$26,print_lf

	# Print device number

	lda	$17,dev
	br	$26,write_stdout

	ldl	$16,(stat_buf+STAT_DEV)
	br	$26,print_decimal
	br	$26,print_lf

	# print Mode
	
	lda	$17,mode
	br	$26,write_stdout
	ldl	$16,(stat_buf+STAT_MODE)
	br	$26,print_octal
	br	$26,print_lf
	
	# print nlink
	
	lda	$17,nlink
	br	$26,write_stdout
	ldl	$16,(stat_buf+STAT_NLINK)
	br	$26,print_decimal
	br	$26,print_lf
	
	# print uid
	
	lda	$17,uid
	br	$26,write_stdout
	ldl	$16,(stat_buf+STAT_UID)
	br	$26,print_decimal
	br	$26,print_lf
	
	# print gid
	
	lda	$17,gid
	br	$26,write_stdout
	ldl	$16,(stat_buf+STAT_GID)
	br	$26,print_decimal
	br	$26,print_lf	
	
	# print rdev
	
	lda	$17,rdev
	br	$26,write_stdout
	ldl	$16,(stat_buf+STAT_RDEV)
	br	$26,print_decimal
	br	$26,print_lf
	
	# print size
	
	lda	$17,size
	br	$26,write_stdout
	ldq	$16,(stat_buf+STAT_SIZE)	

	br	$26,print_decimal

	br	$26,print_lf	
	
	# print blksize
	
	lda	$17,blksize
	br	$26,write_stdout
	ldl	$16,(stat_buf+STAT_BLKSIZE)
	br	$26,print_decimal
	br	$26,print_lf		
	
	# print blocks
	
	lda	$17,blocks
	br	$26,write_stdout
	ldl	$16,(stat_buf+STAT_BLOCKS)
	br	$26,print_decimal
	br	$26,print_lf		
	
	# print atime
	
	lda	$17,atime
	br	$26,write_stdout
	ldq	$16,(stat_buf+STAT_ATIME)
	br	$26,print_decimal
	br	$26,print_lf			

	# print mtime
	
	lda	$17,mtime
	br	$26,write_stdout
	ldq	$16,(stat_buf+STAT_MTIME)
	br	$26,print_decimal
	br	$26,print_lf
	
	# print ctime
	
	lda	$17,ctime
	br	$26,write_stdout
	ldq     $16,(stat_buf+STAT_CTIME)
	br	$26,print_decimal
	br	$26,print_lf
	
	# print ino
	
	lda	$17,ino
	br	$26,write_stdout
	ldl	$16,(stat_buf+STAT_INO)
	br	$26,print_decimal
	br	$26,print_lf	

	mov	$27,$26
	ret	$26
	
	#=================
	# print stat64 struct
	#=================

print_stat64:

	# Print filename
	
	mov	$16,$17
	mov	$26,$27
	
	br	$26,write_stdout

	br	$26,print_lf

	# Print device number
	
	lda	$17,dev
	br	$26,write_stdout
	
	ldq	$16,(stat_buf+STAT64_DEV)
	br	$26,print_decimal
	br	$26,print_lf

	# print Mode
	
	lda	$17,mode
	br	$26,write_stdout
	ldl	$16,(stat_buf+STAT64_MODE)
	br	$26,print_octal
	br	$26,print_lf
	
	# print nlink
	
	lda	$17,nlink
	br	$26,write_stdout
	ldl	$16,(stat_buf+STAT64_NLINK)
	br	$26,print_decimal
	br	$26,print_lf
	
	# print uid
	
	lda	$17,uid
	br	$26,write_stdout
	ldl	$16,(stat_buf+STAT64_UID)
	br	$26,print_decimal
	br	$26,print_lf
	
	# print gid
	
	lda	$17,gid
	br	$26,write_stdout
	ldl	$16,(stat_buf+STAT64_GID)
	br	$26,print_decimal
	br	$26,print_lf	
	
	# print rdev
	
	lda	$17,rdev
	br	$26,write_stdout
	ldq	$16,(stat_buf+STAT64_RDEV)
	br	$26,print_decimal
	br	$26,print_lf
	
	# print size
	
	lda	$17,size
	br	$26,write_stdout
	ldq	$16,(stat_buf+STAT64_SIZE)	

	br	$26,print_decimal

	br	$26,print_lf	
	
	# print blksize
	
	lda	$17,blksize
	br	$26,write_stdout
	ldl	$16,(stat_buf+STAT64_BLKSIZE)
	br	$26,print_decimal
	br	$26,print_lf		
	
	# print blocks
	
	lda	$17,blocks
	br	$26,write_stdout
	ldq	$16,(stat_buf+STAT64_BLOCKS)
	br	$26,print_decimal
	br	$26,print_lf		
	
	# print atime
	
	lda	$17,atime
	br	$26,write_stdout
	ldq	$16,(stat_buf+STAT64_ATIME)
	br	$26,print_decimal
	lda	$17,comma
	br	$26,write_stdout
	ldq	$16,(stat_buf+STAT64_ATIME_NSEC)
	br	$26,print_decimal	
	br	$26,print_lf			

	# print mtime
	
	lda	$17,mtime
	br	$26,write_stdout
	ldq	$16,(stat_buf+STAT64_MTIME)
	br	$26,print_decimal
	lda	$17,comma
	br	$26,write_stdout
	ldq	$16,(stat_buf+STAT64_MTIME_NSEC)
	br	$26,print_decimal	
	br	$26,print_lf
	
	# print ctime
	
	lda	$17,ctime
	br	$26,write_stdout
	ldq     $16,(stat_buf+STAT64_CTIME)
	br	$26,print_decimal
	lda	$17,comma
	br	$26,write_stdout
	ldq	$16,(stat_buf+STAT64_CTIME_NSEC)
	br	$26,print_decimal	
	br	$26,print_lf
	
	# print ino
	
	lda	$17,ino
	br	$26,write_stdout
	ldq	$16,(stat_buf+STAT64_INO)
	br	$26,print_decimal
	br	$26,print_lf	

	mov	$27,$26
	ret	$26	
	
our_exit:

#	mov	$good,%rcx
#	call	write_stdout
#	call	print_lf

	# fall through to exit

.include "../common/library.alpha"



.data

stat:           .ascii  "stat \0"
stat64:         .ascii  "stat64 \0"
fstat:          .ascii  "fstat \0"
fstat64:        .ascii  "fstat64 \0"
test_file:      .ascii  "./stat.i386.s\0"
fake_file:      .ascii  "BLARGH\0"
dev:            .ascii  " dev:     \0"
mode:           .ascii  " mode:    \0"
nlink:          .ascii  " nlink:   \0"
uid:            .ascii  " uid:     \0"
gid:            .ascii  " gid:     \0"
rdev:           .ascii  " rdev:    \0"
size:           .ascii  " size:    \0"
blksize:        .ascii  " blksize: \0"
blocks:         .ascii  " blocks:  \0"
atime:          .ascii  " atime:   \0"
mtime:          .ascii  " mtime:   \0"
ctime:          .ascii  " ctime:   \0"
ino:            .ascii  " ino:     \0"
comma:          .ascii  ",\0"
correct:        .ascii  "correct\0"
stat_buf:       .fill   STAT64_STRUCT_SIZE, 1, 0x56
good:           .ascii  "Good\0"
