.include "../common/syscalls.i386"

	.globl _start	
_start:	
	# Linux has gone through a lot of
	#  stat related changes over the years

        # oldstat    18   un
	# oldfstat   28	  un
	# oldlstat   84	  un
	# stat      106	  un
	# lstat     107	  un
	# fstat	    108	  un
	# stat64    195	  stat64Func<X86Linux32>
	# lstat64   196	  un
	# fstat64   197	  fstat64Func<X86Linux32>
	# fstatat64 300   un

# linux-2.6.31/arch/x86/include/asm/stat.h

# struct stat {
#        unsigned long  st_dev;            /* ID of device containing file */
#        unsigned long  st_ino;            /* inode number */
#        unsigned short st_mode;           /* protection */
#        unsigned short st_nlink;          /* number of hard links */
#        unsigned short st_uid;            /* user ID of owner */
#        unsigned short st_gid;            /* group ID of owner */
#        unsigned long  st_rdev;           /* device ID (if special file) */
#        unsigned long  st_size;           /* total size, in bytes */
#        unsigned long  st_blksize;        /* blocksize for file system I/O */
#        unsigned long  st_blocks;         /* number of 512B blocks allocated */
#        unsigned long  st_atime;          /* time of last access */
#        unsigned long  st_atime_nsec;
#        unsigned long  st_mtime;          /* time of last modification */
#        unsigned long  st_mtime_nsec;
#        unsigned long  st_ctime;
#        unsigned long  st_ctime_nsec;     /* time of last status change */
#        unsigned long  __unused4;
#        unsigned long  __unused5;
#};
#
#struct stat64 {
# 0      unsigned long long st_dev;
# 8      unsigned char      __pad0[4];
# 12     unsigned long      __st_ino;
# 16     unsigned int       st_mode;
# 20     unsigned int       st_nlink;
# 24     unsigned long      st_uid;
# 28     unsigned long      st_gid;
# 32     unsigned long long st_rdev;
# 40     unsigned char      __pad3[4];
# 44     long long          st_size;
# 52     unsigned long      st_blksize; 
# 56     unsigned long long st_blocks;   /* Number 512-byte blocks allocated. */
# 60     unsigned long      st_atime;
# 64     unsigned long      st_atime_nsec;
# 68     unsigned long      st_mtime;
# 72     unsigned int       st_mtime_nsec;
# 76     unsigned long      st_ctime;
# 80     unsigned long      st_ctime_nsec;
# 84     unsigned long long st_ino;
# 92   padding?
# 96
# };

	# run stat64

	mov	$SYSCALL_STAT64,%eax
	mov	$test_file,%ebx
	mov	$stat_buf,%ecx
	int	$0x80

	mov	$stat64,%ecx
	call	write_stdout
	
	mov	$test_file,%ebx
	call	print_stat64
	call	print_lf

	# run fstat64
	
	mov     $SYSCALL_OPEN,%eax
	mov	$test_file,%ebx
	mov	$O_RDONLY,%ecx
	int	$0x80
	
	push	%eax
	
	pop	%ebx
	push	%ebx
	
	mov	$SYSCALL_FSTAT64,%eax
	mov	$stat_buf,%ecx
	int	$0x80
	
	mov	$SYSCALL_CLOSE,%eax
	int	$0x80

	mov	$fstat64,%ecx
	call	write_stdout

	mov	$test_file,%ebx
	call	print_stat64
	call	print_lf

	# run lstat64???
	# not implemented m5

	# test stat64 on invalid file

	mov	$SYSCALL_STAT64,%eax
	mov	$fake_file,%ebx
	mov	$stat_buf,%ecx
	int	$0x80

	cmp	$0,%eax
	jge	wrong_answer
	
	mov	$correct,%ecx
        call	write_stdout
	call	print_lf
	
	
wrong_answer:

	jmp	our_exit


	#=================
	# print stat64 struct
	#=================

print_stat64:

	# Print filename
	
	mov	%ebx,%ecx
	call	write_stdout

	call	print_lf

	# Print device number
	
	mov	$dev,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_DEV),%eax
	call	print_decimal
	mov	$comma,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_DEV+4),%eax
	call	print_decimal	
	call	print_lf

	# print Mode
	
	mov	$mode,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_MODE),%eax
	call	print_octal
	call	print_lf
	
	# print nlink
	
	mov	$nlink,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_NLINK),%eax
	call	print_decimal
	call	print_lf
	
	# print uid
	
	mov	$uid,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_UID),%eax
	call	print_decimal
	call	print_lf
	
	# print gid
	
	mov	$gid,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_GID),%eax
	call	print_decimal
	call	print_lf	
	
	# print rdev
	
	mov	$rdev,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_RDEV),%eax
	call	print_decimal
	mov	$comma,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_RDEV+4),%eax
	call	print_decimal	
	call	print_lf
	
	# print size
	
	mov	$size,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_SIZE),%eax
	call	print_decimal
	mov	$comma,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_SIZE+4),%eax
	call	print_decimal	
	call	print_lf	
	
	# print blksize
	
	mov	$blksize,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_BLKSIZE),%eax
	call	print_decimal
	call	print_lf		
	
	# print blocks
	
	mov	$blocks,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_BLOCKS),%eax
	call	print_decimal
	mov	$comma,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_BLOCKS+4),%eax
	call	print_decimal	
	call	print_lf		
	
	# print atime
	
	mov	$atime,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_ATIME),%eax
	call	print_decimal
	mov	$comma,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_ATIME_NSEC),%eax
	call	print_decimal	
	call	print_lf			

	# print mtime
	
	mov	$mtime,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_MTIME),%eax
	call	print_decimal
	mov	$comma,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_MTIME_NSEC),%eax
	call	print_decimal	
	call	print_lf
	
	# print ctime
	
	mov	$ctime,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_CTIME),%eax
	call	print_decimal
	mov	$comma,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_CTIME_NSEC),%eax
	call	print_decimal	
	call	print_lf
	
	# print ino
	
	mov	$ino,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_INO),%eax
	call	print_decimal
	mov	$comma,%ecx
	call	write_stdout
	mov	(stat_buf+ST64_INO+4),%eax
	call	print_decimal	
	call	print_lf	

	ret
	
our_exit:

	mov	$good,%ecx
	call	write_stdout
	call	print_lf

	# fall through to exit

.include "../common/library.i386"

.data
stat64:		.ascii  "stat64 \0"
fstat64:	.ascii  "fstat64 \0"
lstat64:	.ascii  "lstat64 \0"
test_file:	.ascii  "./stat.i386.s\0"
fake_file:	.ascii	"BLARGH\0"
dev:		.ascii	" dev:     \0"
mode:		.ascii  " mode:    \0"
nlink:		.ascii  " nlink:   \0"
uid:		.ascii  " uid:     \0"
gid:		.ascii  " gid:     \0"
rdev:		.ascii  " rdev:    \0"
size:		.ascii  " size:    \0"
blksize:	.ascii	" blksize: \0"
blocks:		.ascii	" blocks:  \0"
atime:		.ascii	" atime:   \0"
mtime:		.ascii	" mtime:   \0"
ctime:		.ascii	" ctime:   \0"
ino:		.ascii	" ino:     \0"
comma:		.ascii	",\0"
correct:	.ascii  "correct\0"
stat_buf:	.fill	STAT64_SIZE, 1, 0x56
good:		.ascii	"Good\0"

