.include "../common/syscalls.x86_64"

	.globl _start	
_start:	
	# Linux has gone through a lot of
	#  stat related changes over the years

	# stat      4	  un
	# lstat     6	  un
	# fstat	    5	  fstat64Func<X86Linux64>
	# fstatat   ?	  un

# linux-2.6.31/arch/x86/include/asm/stat.h

#struct stat {
# 0      unsigned long   st_dev;
# 8      unsigned long   st_ino;
# 16     unsigned long   st_nlink;
# 24     unsigned int    st_mode;
# 28     unsigned int    st_uid;
# 32     unsigned int    st_gid;
# 36     unsigned int    __pad0;
# 40     unsigned long   st_rdev;
# 48     long            st_size;
# 56     long            st_blksize;
# 64     long            st_blocks;      /* Number 512-byte blocks allocated. */
# 72     unsigned long   st_atime;
# 80     unsigned long   st_atime_nsec;
# 88     unsigned long   st_mtime;
# 96     unsigned long   st_mtime_nsec;
# 104    unsigned long   st_ctime;
# 112    unsigned long   st_ctime_nsec;  
# 120    long            __unused[3];
# 144
#};

	# run stat64

	mov	$SYSCALL_STAT,%rax
	mov	$test_file,%rdi
	mov	$stat_buf,%rsi
	syscall

	mov	$stat,%rcx
	call	write_stdout
	
	mov	$test_file,%rbx
	call	print_stat64
	call	print_lf

	# run fstat
	
	mov     $SYSCALL_OPEN,%rax
	mov	$test_file,%rdi
	mov	$O_RDONLY,%rsi
	syscall
	
	push	%rax
	
	pop	%rdi
	push	%rdi
	
	mov	$SYSCALL_FSTAT,%rax
	mov	$stat_buf,%rsi
	syscall
	
	mov	$SYSCALL_CLOSE,%rax
	syscall

	mov	$fstat,%rcx
	call	write_stdout

	mov	$test_file,%rbx
	call	print_stat64
	call	print_lf

	# run lstat???
	# not implemented m5

	# test stat on invalid file

	mov	$SYSCALL_STAT,%rax
	mov	$fake_file,%rdi
	mov	$stat_buf,%rsi
	syscall

	cmp	$0,%rax
	jge	wrong_answer
	
	mov	$correct,%rcx
        call	write_stdout
	call	print_lf
	
	
wrong_answer:

	jmp	our_exit


	#=================
	# print stat64 struct
	#=================

print_stat64:

	# Print filename
	
	mov	%rbx,%rcx
	call	write_stdout

	call	print_lf

	# Print device number
	
	mov	$dev,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_DEV),%rax
	call	print_decimal
	call	print_lf

	# print Mode
	
	mov	$mode,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_MODE),%eax
	call	print_octal
	call	print_lf
	
	# print nlink
	
	mov	$nlink,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_NLINK),%rax
	call	print_decimal
	call	print_lf
	
	# print uid
	
	mov	$uid,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_UID),%eax
	call	print_decimal
	call	print_lf
	
	# print gid
	
	mov	$gid,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_GID),%eax
	call	print_decimal
	call	print_lf	
	
	# print rdev
	
	mov	$rdev,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_RDEV),%rax
	call	print_decimal
	call	print_lf
	
	# print size
	
	mov	$size,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_SIZE),%rax
	call	print_decimal
	call	print_lf	
	
	# print blksize
	
	mov	$blksize,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_BLKSIZE),%rax
	call	print_decimal
	call	print_lf		
	
	# print blocks
	
	mov	$blocks,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_BLOCKS),%rax
	call	print_decimal
	call	print_lf		
	
	# print atime
	
	mov	$atime,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_ATIME),%rax
	call	print_decimal
	mov	$comma,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_ATIME_NSEC),%rax
	call	print_decimal	
	call	print_lf			

	# print mtime
	
	mov	$mtime,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_MTIME),%rax
	call	print_decimal
	mov	$comma,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_MTIME_NSEC),%rax
	call	print_decimal	
	call	print_lf
	
	# print ctime
	
	mov	$ctime,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_CTIME),%rax
	call	print_decimal
	mov	$comma,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_CTIME_NSEC),%rax
	call	print_decimal	
	call	print_lf
	
	# print ino
	
	mov	$ino,%rcx
	call	write_stdout
	mov	(stat_buf+ST64_INO),%rax
	call	print_decimal
	call	print_lf	

	ret
	
our_exit:

	mov	$good,%rcx
	call	write_stdout
	call	print_lf

	# fall through to exit

.include "../common/library.x86_64"

.data
stat:		.ascii  "stat \0"
fstat:		.ascii  "fstat \0"
lstat:		.ascii  "lstat \0"
test_file:	.ascii  "./stat.i386.s\0"
fake_file:	.ascii	"BLARGH\0"
dev:		.ascii	" dev:     \0"
mode:		.ascii  " mode:    \0"
nlink:		.ascii  " nlink:   \0"
uid:		.ascii  " uid:     \0"
gid:		.ascii  " gid:     \0"
rdev:		.ascii  " rdev:    \0"
size:		.ascii  " size:    \0"
blksize:	.ascii	" blksize: \0"
blocks:		.ascii	" blocks:  \0"
atime:		.ascii	" atime:   \0"
mtime:		.ascii	" mtime:   \0"
ctime:		.ascii	" ctime:   \0"
ino:		.ascii	" ino:     \0"
comma:		.ascii	",\0"
correct:	.ascii  "correct\0"
stat_buf:	.fill	STAT64_SIZE, 1, 0x56
good:		.ascii	"Good\0"

