.include "../common/syscalls.x86_64"

	.globl _start	
_start:	

	# time   201

	# normal way

	mov	$time_message,%rcx
	call	write_stdout
	
	xor	%rdi,%rdi   		# NULL pointer, don't want a copy
	movq    $SYSCALL_TIME, %rax
	syscall

	call    print_decimal
	call	print_lf
	
	# in mem

	mov	$mem_message,%rcx
	call	write_stdout
	
	mov	$time_mem,%rdi
	movq    $SYSCALL_TIME, %rax
	syscall
	
	movq    time_mem,%rax

	call    print_decimal
	call	print_lf	

	# vsyscall
	
	mov	$vsys_message,%rcx
	call	write_stdout

	xor    %rdi,%rdi
	mov    $0xffffffffff600400,%rax
	callq  *%rax
  		
  	call	print_decimal
	call	print_lf

        jmp	our_exit
	
fail:	
	mov	$fail_message,%rcx
	call	write_stdout
	jmp	our_exit

our_exit:

	# fall through to exit

.include "../common/library.x86_64"

.data
time_message:	.ascii  "Time since 1 January 1970 : \0"
mem_message:    .ascii  " same time, written to mem: \0"
vsys_message:	.ascii  " same time, using vsyscall: \0"
fail_message:	.ascii  "FAIL!\n\0"

time_mem:	.ascii "ABCD1234\0"

