.include "../common/syscalls.i386"

	.globl _start	
_start:	

	# truncate   92   un
	# ftruncate  93	  un
	# truncate64 193  un
	# ftruncate64 194 un

	###############################
	#
	# Test truncate and truncate64
	#
	###############################

	# create an 8KB file
	
	call	create_8KB

	# verify it is 8KB

	mov	$SYSCALL_STAT64,%eax
	mov	$test_file,%ebx
	mov	$stat_buf,%ecx
	int	$0x80

	mov	(stat_buf+ST64_SIZE),%eax
	cmp	$8192,%eax
	jne	fail

	mov	$create_8kb,%ecx
	call	write_stdout
	
	# Truncate file to 2kb using truncate
	
	mov	$SYSCALL_TRUNCATE,%eax
	mov	$test_file,%ebx
	mov	$2048,%ecx
	int	$0x80
	
	# verify it worked
	
	mov	$SYSCALL_STAT64,%eax
	mov	$test_file,%ebx
	mov	$stat_buf,%ecx
	int	$0x80

	mov	(stat_buf+ST64_SIZE),%eax
	cmp	$2048,%eax
	jne	fail

	mov	$trunc_2kb,%ecx
	call	write_stdout	
	
	# Truncate to 1kb using truncate64
	
	mov	$SYSCALL_TRUNCATE64,%eax
	mov	$test_file,%ebx
	mov	$1024,%ecx
	mov	$0,%edx
	int	$0x80	
	
	# verify it worked
	
	mov	$SYSCALL_STAT64,%eax
	mov	$test_file,%ebx
	mov	$stat_buf,%ecx
	int	$0x80

	mov	(stat_buf+ST64_SIZE),%eax
	cmp	$1024,%eax
	jne	fail

	mov	$trunc_1kb,%ecx
	call	write_stdout	
	
	###############################
	#
	# Test ftruncate and ftruncate64
	#
	###############################

	# create an 8KB file
	
	call	create_8KB

	mov	$SYSCALL_OPEN,%eax
	mov	$test_file,%ebx
	mov	$(O_WRONLY),%ecx
	int	$0x80

	push	%eax
	pop	%ebx

	# verify it is 8KB

	mov	$SYSCALL_FSTAT64,%eax
	mov	$stat_buf,%ecx
	int	$0x80

	mov	(stat_buf+ST64_SIZE),%eax
	cmp	$8192,%eax
	jne	fail

	push	%ebx

	mov	$create_8kb,%ecx
	call	write_stdout
	
	pop	%ebx
	
	# Truncate file to 2kb using ftruncate
	
	mov	$SYSCALL_FTRUNCATE,%eax
	mov	$2048,%ecx
	int	$0x80
	
	# verify it worked
	
	mov	$SYSCALL_FSTAT64,%eax
	mov	$stat_buf,%ecx
	int	$0x80

	mov	(stat_buf+ST64_SIZE),%eax
	cmp	$2048,%eax
	jne	fail

	push	%ebx

	mov	$ftrunc_2kb,%ecx
	call	write_stdout	
	
	# Truncate to 1kb using truncate64
	
	pop	%ebx
	mov	$SYSCALL_FTRUNCATE64,%eax
	mov	$1024,%ecx
	mov	$0,%edx
	int	$0x80	
	
	# verify it worked
	
	mov	$SYSCALL_FSTAT64,%eax
	mov	$stat_buf,%ecx
	int	$0x80

	mov	(stat_buf+ST64_SIZE),%eax
	cmp	$1024,%eax
	jne	fail

	push	%ebx

	mov	$ftrunc_1kb,%ecx
	call	write_stdout		
	
	pop	%ebx
	mov	$SYSCALL_CLOSE,%eax
	int	$0x80
	
        jmp	our_exit
	
fail:	
	mov	$fail_message,%ecx
	call	write_stdout
	jmp	our_exit

	#####################
	# create_8KB
	#####################
	# Create 8KB file

create_8KB:
	mov     $SYSCALL_OPEN,%eax
	mov	$test_file,%ebx
	mov	$(O_WRONLY|O_CREAT|O_TRUNC),%ecx
	mov	$0644,%edx
	int	$0x80
	
	# 8192/32 = 4096/16 = 2048/8 = 1024/4 = 512/2 = 256

	push	%eax
	pop	%ebx
	
	mov	$256,%edi
	
write_loop:	
	
	mov	$SYSCALL_WRITE,%eax
	mov	$fill_string,%ecx
	mov	$32,%edx
	int	$0x80
	
	dec	%edi
	jnz	write_loop
	
	mov	$SYSCALL_CLOSE,%eax
	int	$0x80
	
	ret



our_exit:

	# fall through to exit

.include "../common/library.i386"

.data
test_file:	.ascii	"test\0"
fill_string:    .ascii  "3.141592653589793238462643383279502884197169399\0"
fail_message:	.ascii  "FAIL!\n\0"
create_8kb:	.ascii  "Created 8KB OK\n\0"
trunc_2kb:	.ascii	"truncate to 2KB OK\n\0"
trunc_1kb:	.ascii	"truncate64 to 1KB OK\n\0"
ftrunc_2kb:	.ascii	"ftruncate to 2KB OK\n\0"
ftrunc_1kb:	.ascii	"ftruncate64 to 1KB OK\n\0"
.bss
.lcomm	stat_buf,ST64_SIZE
