.include "../common/syscalls.x86_64"

	.globl _start	
_start:	

	# truncate   76   un
	# ftruncate  77	  un

	###############################
	#
	# Test truncate
	#
	###############################

	# create an 8KB file
	
	call	create_8KB

	# verify it is 8KB

	mov	$SYSCALL_STAT,%rax
	mov	$test_file,%rdi
	mov	$stat_buf,%rsi
	syscall

	mov	(stat_buf+ST64_SIZE),%rax
	cmp	$8192,%rax
	jne	fail

	mov	$create_8kb,%rcx
	call	write_stdout
	
	# Truncate file to 2kb using truncate
	
	mov	$SYSCALL_TRUNCATE,%rax
	mov	$test_file,%rdi
	mov	$2048,%rsi
        syscall
	
	# verify it worked
	
	mov	$SYSCALL_STAT,%rax
	mov	$test_file,%rdi
	mov	$stat_buf,%rsi
	syscall

	mov	(stat_buf+ST64_SIZE),%rax
	cmp	$2048,%rax
	jne	fail

	mov	$trunc_2kb,%rcx
	call	write_stdout	
	
	###############################
	#
	# Test ftruncate
	#
	###############################

	# create an 8KB file
	
	call	create_8KB

	mov	$SYSCALL_OPEN,%rax
	mov	$test_file,%rdi
	mov	$(O_WRONLY),%rsi
	syscall

	push	%rax
	pop	%rdi

	# verify it is 8KB

	mov	$SYSCALL_FSTAT,%rax
	mov	$stat_buf,%rsi
	syscall

	mov	(stat_buf+ST64_SIZE),%rax
	cmp	$8192,%rax
	jne	fail

	push	%rdi

	mov	$create_8kb,%rcx
	call	write_stdout
	
	pop	%rdi
	
	# Truncate file to 2kb using ftruncate
	
	mov	$SYSCALL_FTRUNCATE,%rax
	mov	$2048,%rsi
	syscall
	
	# verify it worked
	
	mov	$SYSCALL_FSTAT,%rax
	mov	$stat_buf,%rsi
	syscall

	mov	(stat_buf+ST64_SIZE),%rax
	cmp	$2048,%rax
	jne	fail

	push	%rdi

	mov	$ftrunc_2kb,%rcx
	call	write_stdout	
	
        jmp	our_exit
	
fail:	
	mov	$fail_message,%rcx
	call	write_stdout
	jmp	our_exit

	#####################
	# create_8KB
	#####################
	# Create 8KB file

create_8KB:
	mov     $SYSCALL_OPEN,%rax
	mov	$test_file,%rdi
	mov	$(O_WRONLY|O_CREAT|O_TRUNC),%rsi
	mov	$0644,%rdx
	syscall
	
	# 8192/32 = 4096/16 = 2048/8 = 1024/4 = 512/2 = 256

	push	%rax
	pop	%rdi
	
	mov	$256,%r9
	
write_loop:	
	
	mov	$SYSCALL_WRITE,%rax
	mov	$fill_string,%rsi
	mov	$32,%rdx
	syscall
	
	dec	%r9
	jnz	write_loop
	
	mov	$SYSCALL_CLOSE,%rax
	syscall
	
	ret



our_exit:

	# fall through to exit

.include "../common/library.x86_64"

.data
test_file:	.ascii	"test\0"
fill_string:    .ascii  "3.141592653589793238462643383279502884197169399\0"
fail_message:	.ascii  "FAIL!\n\0"
create_8kb:	.ascii  "Created 8KB OK\n\0"
trunc_2kb:	.ascii	"truncate to 2KB OK\n\0"
trunc_1kb:	.ascii	"truncate64 to 1KB OK\n\0"
ftrunc_2kb:	.ascii	"ftruncate to 2KB OK\n\0"
ftrunc_1kb:	.ascii	"ftruncate64 to 1KB OK\n\0"
.bss
.lcomm	stat_buf,ST64_SIZE
