# This exhibited a (now-fixed) bug in m5 x86 support


# Syscalls
.equ SYSCALL_EXIT,     1
.equ SYSCALL_WRITE,    4

#
.equ STDIN,0
.equ STDOUT,1
.equ STDERR,2

	.globl _start	
_start:	

	mov	$hello,%ecx
	call	*write

	#================================
	# Exit
	#================================
exit:
	xor     %ebx,%ebx
	xor	%eax,%eax
	inc	%eax	 		# put exit syscall number (1) in eax
	int     $0x80             	# and exit


	#================================
	# WRITE_STDOUT
	#================================
	# ecx has string
	# eax,ebx,ecx,edx trashed
write_stdout:
	push    %edx
	push	$SYSCALL_WRITE		# put 4 in eax (write syscall)
	pop     %eax     		# in 3 bytes of code
	
	cdq   	      			# clear edx
	
	xor	%ebx,%ebx		# put 1 in ebx (stdout)
	inc	%ebx			# in 3 bytes of code
	
			# another way of doing this:    lea 1(%edx), %ebx

str_loop1:
	inc	%edx
	cmpb	$0,(%ecx,%edx)		# repeat till zero
	jne	str_loop1

	int	$0x80  			# run the syscall
	pop	%edx
	ret

vsyscall:
	.byte    0x51       # push %ecx
	.byte    0x52       # push %edp
	.byte    0x55       # push %ebp
	.byte    0x89, 0xe5 # mov %esp, %ebp
        .byte    0x0f, 0x34 # sysenter
						

#===========================================================================
#	section .data
#===========================================================================
.data

hello:	.ascii "Hello World!\n\0"
write:	.int   write_stdout

#============================================================================
#	section .bss
#============================================================================
.bss

