# This tests cvtdq2ps on x86_64

.include "../common/syscalls.x86_64"

	.globl _start	
_start:	


	#
	# Test 1
	#

	mov	      $cvtdq2ps_label,%rcx
	call	      write_stdout
	call	      print_lf

        cvtdq2ps      source1,%xmm0		# move 8,4,2,1 into xmm0

	mov	      $xmm0l_label,%rcx		# print xmm0=
	call	      write_stdout

	movd	      %xmm0,%rax
	call	      print_hex
	call	      print_lf

	mov	      $cvtps2dq_label,%rcx
	call	      write_stdout
	call	      print_lf

	mov	      $xmm2l_label,%rcx		# print xmm0=
	call	      write_stdout



	cvtps2dq      %xmm0,%xmm2 		# print value in xmm0

	movq	      %xmm2,%rax
	
	######################
	#####################
	# PROBLEM
	####################
	####################
	
	call	      print_hex
	call	      print_lf

	call	      print_s_xmm2
	call	      print_lf


	cvtps2dq      %xmm0,%xmm2 		# compare val in xmm0
	
	mov	      $1,%r9d
	mov	      $2,%r10d
	mov	      $4,%r11d
	mov	      $8,%r12d
	call	      compare_s_xmm2
	
		
	############
	# Test from qemu test
	###########

	mov	      $cvtdq2ps_label2,%rcx
	call	      write_stdout
	call	      print_lf

	movdqa	      temp3,%xmm0

	mov	      $xmm0l_label,%rcx		# print xmml0=
	call	      write_stdout

	movd	      %xmm0,%rax
	call	      print_hex
	call	      print_lf

	mov	      $xmm0h_label,%rcx		# print xmmh0=
	call	      write_stdout

	movhpd	      %xmm0,temp2
	mov	      temp2,%rax
	call	      print_hex
	call	      print_lf

	mov	      $cvtdq2ps_label2,%rcx
	call	      write_stdout
	call	      print_lf

	mov	      $xmm1l_label,%rcx		# print xmml0=
	call	      write_stdout

	cvtdq2ps      %xmm0,%xmm1 		

	movq	      %xmm1,%rax
	
	call	      print_hex
	call	      print_lf

	mov	      $xmm1h_label,%rcx		# print xmmh1=
	call	      write_stdout

	movhpd	      %xmm1,temp2
	mov	      temp2,%rax
	
	push	      %rax
	
	call	      print_hex
	call	      print_lf


	mov	      $sbe1l_label,%rcx
	call	      write_stdout
	mov	      $sbe1h_label,%rcx
	call	      write_stdout
	
	pop	      %rax
	
	cmp	      $0x42C80000,%eax      
	jne	      fail
	
	shr	      $32,%rax
	cmp	      $0xC76A6000,%eax      
	jne	      fail	


	#######################
	#
	# if we get here, all went well
	#
	#######################

	mov	$good_string,%rcx
	call	write_stdout	

	jmp	our_exit

fail:	
	mov	$bad_string,%rcx
	call	write_stdout	
	jmp	our_exit


	#######################
	# print_s_xmm2
	#######################
	# Print 4 s values in xmm2

print_s_xmm2:

	movq 	      %xmm2,%rax
	call 	      print_hex
	call	      print_lf
	
	movq 	      %xmm0,%rax
	call 	      print_hex
	call	      print_lf	

	movd          %xmm2,%eax	# print first
	call          print_hex
	mov	      $space,%rcx
	call	      write_stdout
	psrldq        $4,%xmm2
								
	movd 	      %xmm2,%eax	# print second
	call          print_hex
	mov	      $space,%rcx
	call	      write_stdout		
	psrldq        $4,%xmm2

			     
	movd          %xmm2,%eax	# print third
	call          print_hex
	mov	      $space,%rcx
	call	      write_stdout	
	psrldq        $4,%xmm2

        movd          %xmm2,%eax	# print fourth
	call          print_hex		
	mov	      $space,%rcx
	call	      write_stdout
        call          print_lf
	
	ret
	
	#######################
	# compare_s_xmm2
	#######################
	# Compares 4 s values in xmm2
	# r9/r10/r11/r12
	
compare_s_xmm2:

	movd          %xmm2,%eax
	cmp           %r9d,%eax
        jne           fail
	psrldq        $4,%xmm2

	movd 	      %xmm2,%eax
	cmp           %r10d,%eax
        jne           fail
	psrldq        $4,%xmm2
	
	movd          %xmm2,%eax
	cmp           %r11d,%eax
	jne           fail
	psrldq        $4,%xmm2

        movd          %xmm2,%eax
	cmp           %r12d,%eax
	jne           fail

	ret

our_exit:

	# fall through to exit

.include "../common/library.x86_64"

.data
.balign 16
.balign 16
source1:                .int  1,2,4,8
source2:                .int 100,200,400,800
out:                    .int  16,17,18,19

temp:		.int  1,2,3,4
temp2:		.int  8,9,10,11

temp3:		.int 0xfffffffa,0x00000002,0x00000064,0xffff15a0




cvtdq2ps_label:         .ascii  "cvtdq2ps   source1,%xmm0\0"
cvtdq2ps_label2:        .ascii  "cvtdq2ps   %xmm0,%xmm1\0"
cvtps2dq_label:		.ascii	"cvtps2dq   %xmm0,%xmm2\0"
xmm0l_label:		.ascii	"           xmm0l = \0"
xmm0h_label:		.ascii	"           xmm0h = \0"
xmm1l_label:		.ascii	"           xmm1l = \0"
xmm1h_label:		.ascii	"           xmm1h = \0"
sbe1l_label:		.ascii	" should be xmm1l = 40000000C0C00000\n\0"
sbe1h_label:		.ascii	" should be xmm1h = C76A600042C80000\n\0"

xmm2l_label:		.ascii	"           xmm2l = \0"

xmm_xmm_label:		.ascii  "\nxmm/xmm:\n\0"

should_be1:             .ascii  "      should be = 1 2 4 8\n\0"
xmm1_label:		.ascii	"           xmm1 = \0"
should_be2:             .ascii  "      should be = 100 200 400 800\n\0"
should_be3:		.ascii	" Should be xmm0 = 1 2 4 8\n"
			.ascii	"           xmm1 = 300 1200 3 12\n\0"
haddps1:		.ascii  " haddps %xmm0,%xmm1\n\0"

xmm_same_label:		.ascii  "\nxmm/xmm same:\n\0"
haddps2:		.ascii  " haddps %xmm0,%xmm0\n\0"
should_be4:		.ascii	" Should be xmm0 = 3 12 3 12\n\0"

xmm_mem_label:		.ascii  "\nxmm/mem:\n\0"
haddps3:		.ascii  " haddps out,%xmm1\n\0"
should_be5:		.ascii	" Should be xmm0 = 1 2 4 8\n"
			.ascii	"           xmm1 = 300 1200 3 12\n\0"

space:		.ascii  " \0"

good_string:	.ascii	"Good\n\0"
bad_string:	.ascii	"Fail\n\0"
