# This tests cvtsi2sd on x86_64

.include "../common/syscalls.x86_64"

	.globl _start	
_start:	

	# this bug was noted in perlbmk/makerand

	########################################
	# Test 64-bit int->xmm with high bit set
	########################################


	mov           $high_label,%rcx
	call	      write_stdout
	mov           $converting1,%rcx
	call	      write_stdout
	mov           $result1,%rcx
	call	      write_stdout	
	

	mov	      $0x00000000d3b055b5,%rax
	cvtsi2sd      %rax,%xmm1
	
	xor	      %rax,%rax
	
	movd	      %xmm1,%rax

	push	      %rax

	call	      print_hex
	call	      print_lf
	
	mov	      $shouldbe1,%rcx
	call	      write_stdout

	pop	      %rax

	cmp	      $0xB6A00000,%eax
	jne	      fail


	#######################################
	# Test 64-bit int->xmm w/o high bit set
	#######################################


	mov           $nohigh_label,%rcx
	call	      write_stdout
	mov           $converting2,%rcx
	call	      write_stdout
	mov           $result2,%rcx
	call	      write_stdout	
	

	mov	      $0x0000000003b055b5,%rax
	cvtsi2sd      %rax,%xmm1
	
	xor	      %rax,%rax
	
	movd	      %xmm1,%rax

	push	      %rax

	call	      print_hex
	call	      print_lf
	
	mov	      $shouldbe2,%rcx
	call	      write_stdout

	pop	      %rax

	cmp	      $0xA8000000,%eax
	jne	      fail




	########################################
	# Test 64-bit mem->xmm with high bit set
	########################################


	mov           $high_mem,%rcx
	call	      write_stdout
	mov           $converting3,%rcx
	call	      write_stdout
	mov           $result3,%rcx
	call	      write_stdout	
	
	mov	      $0x00000000d3b055b5,%rax
	mov	      %rax,temp
	
	rex.w cvtsi2sd      temp,%xmm1
	
	xor	      %rax,%rax
	
	movd	      %xmm1,%rax

	push	      %rax

	call	      print_hex
	call	      print_lf
	
	mov	      $shouldbe3,%rcx
	call	      write_stdout

	pop	      %rax

	cmp	      $0xB6A00000,%eax
	jne	      fail


	#########################################
	# Test a 64-bit mem->xmm w/o high bit set
	#########################################


	mov           $nohigh_label,%rcx
	call	      write_stdout
	mov           $converting4,%rcx
	call	      write_stdout
	mov           $result4,%rcx
	call	      write_stdout	
	

	mov	      $0x0000000003b055b5,%rax
	mov	      %rax,temp
	
	rex.w cvtsi2sd      temp,%xmm1
	
	xor	      %rax,%rax
	
	movd	      %xmm1,%rax

	push	      %rax

	call	      print_hex
	call	      print_lf
	
	mov	      $shouldbe4,%rcx
	call	      write_stdout

	pop	      %rax

	cmp	      $0xA8000000,%eax
	jne	      fail

	
	########################################
	# Test 32-bit int->xmm with high bit set
	########################################


	mov           $high_label_32,%rcx
	call	      write_stdout
	mov           $converting1_32,%rcx
	call	      write_stdout
	mov           $result1_32,%rcx
	call	      write_stdout	
	
	xor	      %rax,%rax
	mov	      $0xd3b055b5,%eax
	cvtsi2sd      %eax,%xmm1
	
	xor	      %rax,%rax
	
	movd	      %xmm1,%rax

	push	      %rax

	call	      print_hex
	call	      print_lf
	
	mov	      $shouldbe1_32,%rcx
	call	      write_stdout

	pop	      %rax

	cmp	      $0x25800000,%eax
	jne	      fail


	#######################################
	# Test 32-bit int->xmm w/o high bit set
	#######################################


	mov           $nohigh_label_32,%rcx
	call	      write_stdout
	mov           $converting2_32,%rcx
	call	      write_stdout
	mov           $result2_32,%rcx
	call	      write_stdout	
	
	xor	      %rax,%rax
	mov	      $0x3b055b5,%eax
	cvtsi2sd      %eax,%xmm1
	
	xor	      %rax,%rax
	
	movd	      %xmm1,%rax

	push	      %rax

	call	      print_hex
	call	      print_lf
	
	mov	      $shouldbe2_32,%rcx
	call	      write_stdout

	pop	      %rax

	cmp	      $0xA8000000,%eax
	jne	      fail




	########################################
	# Test 32-bit mem->xmm with high bit set
	########################################


	mov           $high_mem_32,%rcx
	call	      write_stdout
	mov           $converting3_32,%rcx
	call	      write_stdout
	mov           $result3_32,%rcx
	call	      write_stdout	
	
	mov	      $0xd3b055b5,%eax
	mov	      %eax,temp
	
	cvtsi2sd      temp,%xmm1
	
	xor	      %rax,%rax
	
	movd	      %xmm1,%rax

	push	      %rax

	call	      print_hex
	call	      print_lf
	
	mov	      $shouldbe3_32,%rcx
	call	      write_stdout

	pop	      %rax

	cmp	      $0x25800000,%eax
	jne	      fail


	#########################################
	# Test a 32-bit mem->xmm w/o high bit set
	#########################################


	mov           $nohigh_label_32,%rcx
	call	      write_stdout
	mov           $converting4_32,%rcx
	call	      write_stdout
	mov           $result4_32,%rcx
	call	      write_stdout	
	

	mov	      $0x3b055b5,%eax
	mov	      %rax,temp
	
	cvtsi2sd      temp,%xmm1
	
	xor	      %rax,%rax
	
	movd	      %xmm1,%rax

	push	      %rax

	call	      print_hex
	call	      print_lf
	
	mov	      $shouldbe4_32,%rcx
	call	      write_stdout

	pop	      %rax

	cmp	      $0xA8000000,%eax
	jne	      fail

	jmp	our_exit


fail:	
	mov	$bad_string,%rcx
	call	write_stdout	
	jmp	our_exit

our_exit:

	# fall through to exit

.include "../common/library.x86_64"

.data

temp:	.int 0xdeadbeef,0xcafebabe

high_label:             .ascii  "cvtsi2sd 64-bit reg->xmm high-bit\n\0"
converting1:            .ascii  "  converting 0xd3b055b5\n\0"
result1:		.ascii  "  result    : \0"
shouldbe1:		.ascii  "  should be : 41EA760AB6A00000\n\0"

nohigh_label:           .ascii  "cvtsi2sd 64-bit reg->xmm no high-bit\n\0"
converting2:            .ascii  "  converting 0x3b055b5\n\0"
result2:		.ascii  "  result    : \0"
shouldbe2:		.ascii  "  should be : 418D82ADA8000000\n\0"

high_mem:               .ascii  "cvtsi2sd 64-bit mem->xmm high-bit\n\0"
converting3:            .ascii  "  converting 0xd3b055b5\n\0"
result3:		.ascii  "  result    : \0"
shouldbe3:		.ascii  "  should be : 41EA760AB6A00000\n\0"

nonohigh_mem:           .ascii  "cvtsi2sd 64-bit mem->xmm no high-bit\n\0"
converting4:            .ascii  "  converting 0x3b055b5\n\0"
result4:		.ascii  "  result    : \0"
shouldbe4:		.ascii  "  should be : 418D82ADA8000000\n\0"

high_label_32:             .ascii  "cvtsi2sd 32-bit reg->xmm high-bit\n\0"
converting1_32:            .ascii  "  converting 0xd3b055b5\n\0"
result1_32:		.ascii  "  result    : \0"
shouldbe1_32:		.ascii  "  should be : C1C627D525800000\n\0"

nohigh_label_32:           .ascii  "cvtsi2sd 32-bit reg->xmm no high-bit\n\0"
converting2_32:            .ascii  "  converting 0x3b055b5\n\0"
result2_32:		.ascii  "  result    : \0"
shouldbe2_32:		.ascii  "  should be : 418D82ADA8000000\n\0"

high_mem_32:               .ascii  "cvtsi2sd 32-bit mem->xmm high-bit\n\0"
converting3_32:            .ascii  "  converting 0xd3b055b5\n\0"
result3_32:		.ascii  "  result    : \0"
shouldbe3_32:		.ascii  "  should be : C1C627D525800000\n\0"

nonohigh_mem_32:           .ascii  "cvtsi2sd 32-bit mem->xmm no high-bit\n\0"
converting4_32:            .ascii  "  converting 0x3b055b5\n\0"
result4_32:		.ascii  "  result    : \0"
shouldbe4_32:		.ascii  "  should be : 418D82ADA8000000\n\0"

good_string:	.ascii	"Good\n\0"
bad_string:	.ascii	"Fail\n\0"
