# This tests fld on x86_64

.include "../common/syscalls.x86_64"

	.globl _start	
_start:	

	########################################
	# sanity check fld/fst
	########################################


	mov           $fld_test,%rcx
	call	      write_stdout
	mov           $fld_test1,%rcx
	call	      write_stdout
	
	mov	      $10000,%rax 	# load 10000
	cvtsi2sd      %rax,%xmm1	# convert to fp

	movsd  	      %xmm1,temp	# store to mem
	
        fldl	      temp		# load from mem to st(0)

	call	      print_decimal	# print the orig version
	call	      print_lf

	mov           $fld_test2,%rcx
	call	      write_stdout

	movd	      %xmm1,%rax	# move fp to rax
	call	      print_hex		# print hex version
	call	      print_lf

	xor	      %rax,%rax
	
	fstl	      temp2
	mov	      temp2,%rax
	
	push	      %rax
	
	mov           $fld_test3,%rcx
	call	      write_stdout	
	
	pop	      %rax 
	
	call	      print_hex
	call	      print_lf


	jmp	our_exit


fail:	
	mov	$bad_string,%rcx
	call	write_stdout	
	jmp	our_exit

our_exit:

	# fall through to exit

.include "../common/library.x86_64"

.data

temp:	.int 0xdeadbeef,0xcafebabe
temp2:	.int 0xfeb1378,0xdec3051

fld_test:    .ascii "Testing fld:\n\0"
fld_test1:   .ascii "  Converting: \0"
fld_test2:   .ascii "  Writing to ST(0): \0"
fld_test3:   .ascii "  Read from  ST(0): \0"

good_string:	.ascii	"Good\n\0"
bad_string:	.ascii	"Fail\n\0"
