# This tests fsincos on x86_64

.include "../common/syscalls.x86_64"

	.globl _start	
_start:	


#sine    of 0.000000 (0) = 0.000000 (0)
# cosine of 0.000000 (0) = 1.000000 (3ff0000000000000)
#sine    of 3.141593 (400921fb54442d18) = 0.000000 (3ca1a60000000000)
# cosine of 3.141593 (400921fb54442d18) = -1.000000 (bff0000000000000)
#sine    of 6.283185 (401921fb54442d18) = -0.000000 (bcb1a60000000000)
# cosine of 6.283185 (401921fb54442d18) = 1.000000 (3ff0000000000000)
#sine    of 1.570796 (3ff921fb54442d18) = 1.000000 (3ff0000000000000)
# cosine of 1.570796 (3ff921fb54442d18) = 0.000000 (3c91a60000000000)
#sine    of 0.785398 (3fe921fb54442d18) = 0.707107 (3fe6a09e667f3bcc)
# cosine of 0.785398 (3fe921fb54442d18) = 0.707107 (3fe6a09e667f3bcd)


	########################################
	# Test fsincos
	########################################


        mov           $fsincos_test,%rcx
	call	      write_stdout
	mov           $fsincos_test1,%rcx
	call	      write_stdout
	
	mov	      $0,%rax 	  	# load 0
	cvtsi2sd      %rax,%xmm0	# convert to fp

	movsd  	      %xmm0,-0x8(%rsp)	# save value to stack
	fldl   	      -0x8(%rsp)	# load it into ST(0)
	fsincos 			# sin in ST(0), cos on stack

	xor	      %rax,%rax
	
	fstpl	      temp2    		# get value from ST(0) into mem + pop
	mov	      temp2,%rax	# move to rax
	
	push	      %rax
	
	mov           $fsincos_test3,%rcx
	call	      write_stdout	
	
	pop	      %rax 
	
	call	      print_hex
	call	      print_lf	
	
	
	fstl	      temp2    		# get value from ST(0) into mem
	mov	      temp2,%rax	# move to rax
	
	push	      %rax
	
	mov           $fsincos_test4,%rcx
	call	      write_stdout	
	mov           $fsincos_test5,%rcx
	call	      write_stdout		
	
	pop	      %rax 	
	
	call	      print_hex
	call	      print_lf

	mov           $fsincos_test6,%rcx
	call	      write_stdout		

	#####################################
	# test glibc __sincos routine with 0
	#####################################

	mov	      $sincos1_label1,%rcx
	call	      write_stdout
	mov	      $sincos1_label2,%rcx
	call	      write_stdout	

	mov	      $cosout,%rsi
	mov	      $sinout,%rdi
	mov	      $0,%rax 	  	# load 0
	cvtsi2sd      %rax,%xmm0	# convert to fp	

	call	      __sincos

	mov	      $sincos1_label3,%rcx
	call	      write_stdout	

	mov	      $cosout,%rsi
	mov	      (%rsi),%rax
	call	      print_hex
	call	      print_lf
	
	mov	      $sincos1_label4,%rcx
	call	      write_stdout		
	mov	      $sincos1_label5,%rcx
	call	      write_stdout			

	mov	      $sinout,%rdi
	mov	      (%rdi),%rax
	call	      print_hex
	call	      print_lf

	mov	      $sincos1_label6,%rcx
	call	      write_stdout			
	
	
	#####################################
	# test glibc __sincos routine with pi
	#####################################

	mov	      $sincos2_label1,%rcx
	call	      write_stdout
	mov	      $sincos2_label2,%rcx
	call	      write_stdout	

	mov	      $cosout,%rsi
	mov	      $sinout,%rdi
	
	mov	      $0x400921fb54442d18,%rax	# pi
	movq          %rax,%xmm0	

	call	      __sincos

	mov	      $sincos2_label3,%rcx
	call	      write_stdout	

	mov	      $cosout,%rsi
	mov	      (%rsi),%rax
	call	      print_hex
	call	      print_lf
	
	mov	      $sincos2_label4,%rcx
	call	      write_stdout		
	mov	      $sincos2_label5,%rcx
	call	      write_stdout			

	mov	      $sinout,%rdi
	mov	      (%rdi),%rax
	call	      print_hex
	call	      print_lf

	mov	      $sincos2_label6,%rcx
	call	      write_stdout				
	
	#######################################
	# test glibc __sincos routine with 2*pi
	#######################################

	mov	      $sincos3_label1,%rcx
	call	      write_stdout
	mov	      $sincos3_label2,%rcx
	call	      write_stdout	

	mov	      $cosout,%rsi
	mov	      $sinout,%rdi
	
	mov	      $0x401921fb54442d18,%rax	# 2pi
	movq          %rax,%xmm0	

	call	      __sincos

	mov	      $sincos3_label3,%rcx
	call	      write_stdout	

	mov	      $cosout,%rsi
	mov	      (%rsi),%rax
	call	      print_hex
	call	      print_lf
	
	mov	      $sincos3_label4,%rcx
	call	      write_stdout		
	mov	      $sincos3_label5,%rcx
	call	      write_stdout			

	mov	      $sinout,%rdi
	mov	      (%rdi),%rax
	call	      print_hex
	call	      print_lf

	mov	      $sincos3_label6,%rcx
	call	      write_stdout					

	#######################################
	# test glibc __sincos routine with pi/2
	#######################################

	mov	      $sincos4_label1,%rcx
	call	      write_stdout
	mov	      $sincos4_label2,%rcx
	call	      write_stdout	

	mov	      $cosout,%rsi
	mov	      $sinout,%rdi
	
	mov	      $0x3ff921fb54442d18,%rax	# pi/2
	movq          %rax,%xmm0	

	call	      __sincos

	mov	      $sincos4_label3,%rcx
	call	      write_stdout	

	mov	      $cosout,%rsi
	mov	      (%rsi),%rax
	call	      print_hex
	call	      print_lf
	
	mov	      $sincos4_label4,%rcx
	call	      write_stdout		
	mov	      $sincos4_label5,%rcx
	call	      write_stdout			

	mov	      $sinout,%rdi
	mov	      (%rdi),%rax
	call	      print_hex
	call	      print_lf

	mov	      $sincos4_label6,%rcx
	call	      write_stdout					
	
	#######################################
	# test glibc __sincos routine with pi/4
	#######################################

	mov	      $sincos5_label1,%rcx
	call	      write_stdout
	mov	      $sincos5_label2,%rcx
	call	      write_stdout	

	mov	      $cosout,%rsi
	mov	      $sinout,%rdi
	
	mov	      $0x3fe921fb54442d18,%rax	# pi/4
	movq          %rax,%xmm0	

	call	      __sincos

	mov	      $sincos5_label3,%rcx
	call	      write_stdout	

	mov	      $cosout,%rsi
	mov	      (%rsi),%rax
	call	      print_hex
	call	      print_lf
	
	mov	      $sincos5_label4,%rcx
	call	      write_stdout		
	mov	      $sincos5_label5,%rcx
	call	      write_stdout			

	mov	      $sinout,%rdi
	mov	      (%rdi),%rax
	call	      print_hex
	call	      print_lf

	mov	      $sincos5_label6,%rcx
	call	      write_stdout						


	jmp	our_exit


fail:	
	mov	$bad_string,%rcx
	call	write_stdout	
	jmp	our_exit


__sincos:
	movsd  %xmm0,-0x8(%rsp)		 # save value to stack
	fldl   -0x8(%rsp)		 # load it into ST(0)
	fsincos 			 # sin in ST(0), cos pushed on stack
	fnstsw %ax			 # move status word to ax
	test   $0x400,%eax		 # test to see if too big
	jne    sincos_outofbounds	 # if so, skip ahead
	fstpl  (%rsi)			 # otherwise, store cos to (%rsi)
	fstpl  (%rdi)			 # store sin to (%rdi)
	ret    				 # return   

sincos_outofbounds:

	fldpi  	   			  # load pi
	fadd   %st(0),%st		  # double it to be 2pi
	fxch   %st(1)			  # exchange to have stack set up right

sincos_loop:

	fprem1 				  # divide val by 2pi
	fnstsw %ax			  # check status word again
	test   $0x400,%eax		  #
	jne    sincos_loop		  # keep dividing until in bounds
	fstp   %st(1)
	fsincos 
	fstpl  (%rsi)
	fstpl  (%rdi)
   	ret			 	  # return


#000000000040ea80 <__sincos>:
#  40ea80:       f2 0f 11 44 24 f8       movsd  %xmm0,-0x8(%rsp)
#  40ea86:       dd 44 24 f8             fldl   -0x8(%rsp)
#  40ea8a:       d9 fb                   fsincos 
#  40ea8c:       df e0                   fnstsw %ax
#  40ea8e:       a9 00 04 00 00          test   $0x400,%eax
#  40ea93:       75 05                   jne    40ea9a <__sincos+0x1a>
#  40ea95:       dd 1e                   fstpl  (%rsi)
#  40ea97:       dd 1f                   fstpl  (%rdi)
#  40ea99:       c3                      retq   
#  40ea9a:       d9 eb                   fldpi  
#  40ea9c:       d8 c0                   fadd   %st(0),%st
#  40ea9e:       d9 c9                   fxch   %st(1)
#  40eaa0:       d9 f5                   fprem1 
#  40eaa2:       df e0                   fnstsw %ax
#  40eaa4:       a9 00 04 00 00          test   $0x400,%eax
#  40eaa9:       75 f5                   jne    40eaa0 <__sincos+0x20>
#  40eaab:       dd d9                   fstp   %st(1)
#  40eaad:       d9 fb                   fsincos 
#  40eaaf:       dd 1e                   fstpl  (%rsi)
#  40eab1:       dd 1f                   fstpl  (%rdi)
#  40eab3:       c3                      retq   
	  




our_exit:

	# fall through to exit

.include "../common/library.x86_64"

.data

temp:	.int 0xdeadbeef,0xcafebabe
temp2:	.int 0xfeb1378,0xdec3051
sinout: .int 0xcafecafe,0xbabebabe
cosout:	.int 0xbeefcafe,0x88888888

fsincos_test:    .ascii "Testing fsincos:\n\0"
fsincos_test1:   .ascii "  Converting: 0\n\0"
fsincos_test2:   .ascii "  Trying: 0\n\0"
fsincos_test3:   .ascii "  Read cosine: \0"
fsincos_test4:   .ascii "    should be: 3FF0000000000000\n\0"
fsincos_test5:   .ascii "  Read sine:   \0"
fsincos_test6:   .ascii "    should be: 0000000000000000\n\0"

sincos1_label1:   .ascii "Testing __sincos function:\n\0"
sincos1_label2:   .ascii "  Converting: 0\n\0"
sincos1_label3:   .ascii "  Read cosine: \0"
sincos1_label4:   .ascii "    should be: 3FF0000000000000\n\0"
sincos1_label5:   .ascii "  Read sine:   \0"
sincos1_label6:   .ascii "    should be: 0000000000000000\n\0"


sincos2_label1:   .ascii "Testing __sincos function:\n\0"
sincos2_label2:   .ascii "  Converting: pi\n\0"
sincos2_label3:   .ascii "  Read cosine: \0"
sincos2_label4:   .ascii "    should be: BFF0000000000000\n\0"
sincos2_label5:   .ascii "  Read sine:   \0"
sincos2_label6:   .ascii "    should be: 3CA1A60000000000\n\0"

sincos3_label1:   .ascii "Testing __sincos function:\n\0"
sincos3_label2:   .ascii "  Converting: 2pi\n\0"
sincos3_label3:   .ascii "  Read cosine: \0"
sincos3_label4:   .ascii "    should be: 3FF0000000000000\n\0"
sincos3_label5:   .ascii "  Read sine:   \0"
sincos3_label6:   .ascii "    should be: BCB1A60000000000\n\0"

sincos4_label1:   .ascii "Testing __sincos function:\n\0"
sincos4_label2:   .ascii "  Converting: pi/2\n\0"
sincos4_label3:   .ascii "  Read cosine: \0"
sincos4_label4:   .ascii "    should be: 3C91A60000000000\n\0"
sincos4_label5:   .ascii "  Read sine:   \0"
sincos4_label6:   .ascii "    should be: 3FF0000000000000\n\0"

sincos5_label1:   .ascii "Testing __sincos function:\n\0"
sincos5_label2:   .ascii "  Converting: pi/4\n\0"
sincos5_label3:   .ascii "  Read cosine: \0"
sincos5_label4:   .ascii "    should be: 3FE6A09E667F3BCD\n\0"
sincos5_label5:   .ascii "  Read sine:   \0"
sincos5_label6:   .ascii "    should be: 3FE6A09E667F3BCC\n\0"


good_string:	.ascii	"Good\n\0"
bad_string:	.ascii	"Fail\n\0"
