
# This tests unimplemented haddpd on x86_64

.include "../common/syscalls.x86_64"

	.globl _start	
_start:	

	#########################
	# test xmmm/xmmm
	#########################


	# move 3 and 4 into packed
	
	mov    	      $3,%rax	  	# load 3 into rax
	cvtsi2sd      %rax,%xmm0	# convert to double fp
	
	movlpd	      %xmm0,temp	# move xmm0 low to mem
	movhpd	      temp,%xmm0	# move it back into high
	
	mov    	      $4,%rax		# load 4 into rax
	cvtsi2sd      %rax,%xmm0	# convert to double fp

	# sanity check

	mov	      $label0,%rcx
	call	      write_stdout
	mov	      $label1,%rcx
	call	      write_stdout

	cvtsd2si      %xmm0,%rax	# convert back to int
	call	      print_decimal	# print it
	mov	      $label2,%rcx
	call	      write_stdout

	movhpd	      %xmm0,temp	# store out high value
	movlpd	      temp,%xmm2	# move to low

	cvtsd2si      %xmm2,%rax	# convert back to int
	call	      print_decimal	# print it
	call	      print_lf

	mov    	      $100,%rax	  	# load 100 into rax
	cvtsi2sd      %rax,%xmm1	# convert to double fp
	
	movlpd	      %xmm1,temp	# move xmm1 low to mem
	movhpd	      temp,%xmm1	# move it back into high
	
	mov    	      $200,%rax		# load 200 into rax
	cvtsi2sd      %rax,%xmm1	# convert to double fp
	
	# sanity check

	mov	      $label3,%rcx
	call	      write_stdout

	cvtsd2si      %xmm1,%rax	# convert back to int
	call	      print_decimal	# print it
	mov	      $label4,%rcx
	call	      write_stdout

	movhpd	      %xmm1,temp	# store out high value
	movlpd	      temp,%xmm2	# move to low

	cvtsd2si      %xmm2,%rax	# convert back to int
	call	      print_decimal	# print it
	call	      print_lf
	
	mov	      $label5,%rcx
	call	      write_stdout

	#################
	# all this to test this insn
	#################

	haddpd	      %xmm0,%xmm1	# add xmm1l+xmm1h and store in xmm1l
		      			# add xmm0l+xmm0h and store in xmm1h

	#################
	# Print "should be"
	#################

	mov	      $label6,%rcx
	call	      write_stdout	
 
 	##############
        # print xmm0
        ##############
	
	# print xmm0l
	
	mov	      $label10,%rcx
	call	      write_stdout       
	cvtsd2si      %xmm0,%rax	# convert back to int

	call	      print_decimal	# print it

	# print xmm0h

	movhpd	      %xmm0,temp	# store out high value
	movlpd	      temp,%xmm2	# move to low
	
	cvtsd2si      %xmm2,%rax	# convert back to int

	push	      %rax

	mov	      $label11,%rcx
	call	      write_stdout		

	pop	      %rax

	call	      print_decimal	# print it
	call	      print_lf
	
	#############
	# print xmm1
        #############

	# print xmm1l

	mov	      $label7,%rcx
	call	      write_stdout		

	cvtsd2si      %xmm1,%rax	# convert back to int

	mov	      %rax,%r10

	call	      print_decimal	# print it

	# print xmm1h

	movhpd	      %xmm1,temp	# store out high value
	movlpd	      temp,%xmm2	# move to low
	
	cvtsd2si      %xmm2,%rax	# convert back to int

	push	      %rax

	mov	      $label8,%rcx
	call	      write_stdout		

	pop	      %rax
	push	      %rax

	call	      print_decimal	# print it
	call	      print_lf

	pop	      %rax

	cmp	      $7,%rax
	jne	      fail

	cmp	      $300,%r10
	jne	      fail
	
	
	#########################
	# test xmmm/xmmm on _same reg_
	#########################


	# move 3 and 4 into packed
	
	mov    	      $3,%rax	  	# load 3 into rax
	cvtsi2sd      %rax,%xmm0	# convert to double fp
	
	movlpd	      %xmm0,temp	# move xmm0 low to mem
	movhpd	      temp,%xmm0	# move it back into high
	
	mov    	      $4,%rax		# load 4 into rax
	cvtsi2sd      %rax,%xmm0	# convert to double fp

	# sanity check

	mov	      $label16,%rcx
	call	      write_stdout
	mov	      $label1,%rcx
	call	      write_stdout

	cvtsd2si      %xmm0,%rax	# convert back to int
	call	      print_decimal	# print it
	mov	      $label2,%rcx
	call	      write_stdout

	movhpd	      %xmm0,temp	# store out high value
	movlpd	      temp,%xmm2	# move to low

	cvtsd2si      %xmm2,%rax	# convert back to int
	call	      print_decimal	# print it
	call	      print_lf

	#################
	# all this to test this insn
	#################

	haddpd	      %xmm0,%xmm0	# add xmm0l+xmm0h and store in xmm0l
		      			# add xmm0l+xmm0h and store in xmm0h

	#################
	# Print "should be"
	#################

	mov	      $label17,%rcx
	call	      write_stdout	
 
 	##############
        # print xmm0
        ##############
	
	# print xmm0l
	
	mov	      $label10,%rcx
	call	      write_stdout       
	cvtsd2si      %xmm0,%rax	# convert back to int
	mov	      %rax,%r10		# save to check
	
	call	      print_decimal	# print it

	# print xmm0h

	movhpd	      %xmm0,temp	# store out high value
	movlpd	      temp,%xmm2	# move to low
	
	cvtsd2si      %xmm2,%rax	# convert back to int

	push	      %rax

	mov	      $label11,%rcx
	call	      write_stdout		

	pop	      %rax
	push	      %rax

	call	      print_decimal	# print it
	call	      print_lf
	
	pop	      %rax

	cmp	      $7,%rax
	jne	      fail

	cmp	      $7,%r10
	jne	      fail	


	
	#########################
	# test xmmm/mem
	#########################


	# move 3 and 4 into packed
	
	mov    	      $3,%rax	  	# load 3 into rax
	cvtsi2sd      %rax,%xmm0	# convert to double fp
	
	movlpd	      %xmm0,temp	# move xmm0 low to mem
	movhpd	      temp,%xmm0	# move it back into high
	
	mov    	      $4,%rax		# load 4 into rax
	cvtsi2sd      %rax,%xmm0	# convert to double fp

	# sanity check

	mov	      $label12,%rcx
	call	      write_stdout
	mov	      $label13,%rcx
	call	      write_stdout

	cvtsd2si      %xmm0,%rax	# convert back to int
	call	      print_decimal	# print it
	mov	      $label14,%rcx
	call	      write_stdout

	movhpd	      %xmm0,temp	# store out high value
	movlpd	      temp,%xmm2	# move to low

	cvtsd2si      %xmm2,%rax	# convert back to int
	call	      print_decimal	# print it
	call	      print_lf


	movdqa	      %xmm0,temp2	# store to memory
	

	mov    	      $100,%rax	  	# load 100 into rax
	cvtsi2sd      %rax,%xmm1	# convert to double fp
	
	movlpd	      %xmm1,temp	# move xmm1 low to mem
	movhpd	      temp,%xmm1	# move it back into high
	
	mov    	      $200,%rax		# load 200 into rax
	cvtsi2sd      %rax,%xmm1	# convert to double fp
	
	# sanity check

	mov	      $label3,%rcx
	call	      write_stdout

	cvtsd2si      %xmm1,%rax	# convert back to int
	call	      print_decimal	# print it
	mov	      $label4,%rcx
	call	      write_stdout

	movhpd	      %xmm1,temp	# store out high value
	movlpd	      temp,%xmm2	# move to low

	cvtsd2si      %xmm2,%rax	# convert back to int
	call	      print_decimal	# print it
	call	      print_lf
	
	mov	      $label15,%rcx
	call	      write_stdout

	#################
	# all this to test this insn
	#################

	haddpd	      temp2,%xmm1	# add xmm1l+xmm1h and store in xmm1l
		      			# add xmm0l+xmm0h and store in xmm1h

	#################
	# Print "should be"
	#################

	mov	      $label6,%rcx
	call	      write_stdout	
 
 	##############
        # print xmm0
        ##############
	
	# print xmm0l
	
	mov	      $label10,%rcx
	call	      write_stdout       
	cvtsd2si      %xmm0,%rax	# convert back to int

	call	      print_decimal	# print it

	# print xmm0h

	movhpd	      %xmm0,temp	# store out high value
	movlpd	      temp,%xmm2	# move to low
	
	cvtsd2si      %xmm2,%rax	# convert back to int

	push	      %rax

	mov	      $label11,%rcx
	call	      write_stdout		

	pop	      %rax

	call	      print_decimal	# print it
	call	      print_lf
	
	#############
	# print xmm1
        #############

	# print xmm1l

	mov	      $label7,%rcx
	call	      write_stdout		

	cvtsd2si      %xmm1,%rax	# convert back to int

	mov	      %rax,%r10

	call	      print_decimal	# print it

	# print xmm1h

	movhpd	      %xmm1,temp	# store out high value
	movlpd	      temp,%xmm2	# move to low
	
	cvtsd2si      %xmm2,%rax	# convert back to int

	push	      %rax

	mov	      $label8,%rcx
	call	      write_stdout		

	pop	      %rax
	push	      %rax

	call	      print_decimal	# print it
	call	      print_lf

	pop	      %rax

	cmp	      $7,%rax
	jne	      fail

	cmp	      $300,%r10
	jne	      fail


	#######################
	#
	# if we get here, all went well
	#
	#######################

	mov	$good_string,%rcx
	call	write_stdout	

	jmp	our_exit

fail:	
	mov	$bad_string,%rcx
	call	write_stdout	


our_exit:

	# fall through to exit

.include "../common/library.x86_64"

.data
.balign 16
temp:		.int  1,2,3,4
temp2:		.int  8,9,10,11
label0:		.ascii  "xmm/xmm\n\0"
label1:		.ascii	" xmm0l = \0"
label2:         .ascii  " , xmm0h = \0"
label3:		.ascii  " xmm1l = \0"
label4:         .ascii  " , xmm1h = \0"
label5:		.ascii  " haddpd %xmm0,%xmm1\n\0"
label6:		.ascii	" Should be xmm0l =   4 xmm1h = 3\n"
		.ascii	"           xmm1l = 300 xmm1h = 7\n\0"
label10:	.ascii	" Result is xmm0l =   \0"
label11:	.ascii	" xmm0h = \0"
label7:		.ascii	"           xmm1l = \0"
label8:		.ascii	" xmm1h = \0"

label12:	.ascii  "xmm/mem\n\0"
label13:	.ascii	" meml = \0"
label14:        .ascii  " , memh = \0"
label15:	.ascii  " haddpd mem,%xmm1\n\0"

label16:	.ascii	"xmm/xmm same\n\0"
label17:	.ascii	" Should be xmm0l =   7 xmm1h = 7\n\0"

good_string:	.ascii	"Good\n\0"
bad_string:	.ascii	"Fail\n\0"
