
# This tests unimplemented movd_Vo_Ed on x86_64

.include "../common/syscalls.x86_64"

	.globl _start	
_start:	

	#########################
	# Test XMM to reg32
	#########################

	mov    $reg32,%rcx
	call   write_stdout

	# Fill xmm0
	
	mov     $before,%rcx
	call    write_stdout
	
        movdqu  garbage,%xmm0
	movdqu	%xmm0,output
	
	mov	$output,%rcx
	call	null_change
	call	write_stdout
	call	print_lf

	# write 32-bits to xmm0

	mov	$0x54455354,%eax		# test
	push	%rax	
	mov	$expected,%rcx
	call	write_stdout
	pop	%rax
	push	%rax
	call	print_hex
	call	print_lf
	pop	%rax
	
	movd	%eax,%xmm0
	
	xor	%rax,%rax 			# clear in between
	
	movd	%xmm0,%ecx			# had bug where xmm0 and eax
	mov	%ecx,%eax			# were equivelent, masking
						# the bug
	
	
	push	%rax
	
	mov	$returned,%rcx
	call	write_stdout
	pop	%rax
	push	%rax
	call	print_hex
	call	print_lf

	# after

	mov     $after,%rcx
	call    write_stdout
	
	movdqu	%xmm0,output
	
	mov	$output,%rcx
	call	null_change
	call	write_stdout
	call	print_lf
	
	
	pop	%rax

	cmp	$0x54455354,%eax

	jne	fail
	
		
	#########################
	# Test XMM to reg32 w high bit
	#########################

	mov    $reg32,%rcx
	call   write_stdout

	# Fill xmm0
	
	mov     $before,%rcx
	call    write_stdout
	
        movdqu  garbage,%xmm0
	movdqu	%xmm0,output
	
	mov	$output,%rcx
	call	null_change
	call	write_stdout
	call	print_lf

	# write 32-bits to xmm0

	mov	$0xff455354,%eax		# test
	push	%rax	
	mov	$expected,%rcx
	call	write_stdout
	pop	%rax
	push	%rax
	call	print_hex
	call	print_lf
	pop	%rax
	
	movd	%eax,%xmm0
	
	xor	%rax,%rax 			# clear in between
	
	movd	%xmm0,%ecx			# had bug where xmm0 and eax
	mov	%ecx,%eax			# were equivelent, masking
						# the bug
	
	
	push	%rax
	
	mov	$returned,%rcx
	call	write_stdout
	pop	%rax
	push	%rax
	call	print_hex
	call	print_lf

	# after

	mov     $after,%rcx
	call    write_stdout
	
	movdqu	%xmm0,output
	
	mov	$output,%rcx
	call	null_change
	call	write_stdout
	call	print_lf
	
	
	pop	%rax

	cmp	$0xff455354,%eax

	jne	fail
	

	#########################
	# Test XMM to reg64
	#########################

	mov    $reg64,%rcx
	call   write_stdout

	# Fill xmm0
	
	mov     $before,%rcx
	call    write_stdout
	
        movdqu  garbage,%xmm0
	movdqu	%xmm0,output
	
	mov	$output,%rcx
	call	null_change
	call	write_stdout
	call	print_lf

	# write 32-bits to xmm0

	mov	$0x5445535445535721,%rax		# testesw!
	push	%rax	
	mov	$expected,%rcx
	call	write_stdout
	pop	%rax
	push	%rax
	call	print_hex
	call	print_lf
	pop	%rax
	
	movd	%rax,%xmm0
	
	xor	%rax,%rax 			# clear in between
	
	movd	%xmm0,%rax
	
	push	%rax
	
	mov	$returned,%rcx
	call	write_stdout
	pop	%rax
	push	%rax
	call	print_hex
	call	print_lf

	# after

	mov     $after,%rcx
	call    write_stdout
	
	movdqu	%xmm0,output
	
	mov	$output,%rcx
	call	null_change
	call	write_stdout
	call	print_lf
	
	
	pop	%rax

	cmp	$0x45535721,%eax

	jne	fail



	#########################
	# Test XMM to mem32
	#########################

	mov    $mem32,%rcx
	call   write_stdout


	# Fill xmm0
	
	mov     $before,%rcx
	call    write_stdout
	
        movdqu  garbage,%xmm0
	movdqu	%xmm0,output
	
	mov	$output,%rcx
	call	null_change
	call	write_stdout
	call	print_lf

	# write 32-bits to xmm0

	mov	$0x54455354,%eax		# test
	push	%rax	
	mov	$expected,%rcx
	call	write_stdout
	pop	%rax
	push	%rax
	call	print_hex
	call	print_lf
	pop	%rax
	
	mov	%eax,temp
	
	movd	temp,%xmm0
	
	xor	%eax,%eax 			# clear in between
	
	movd	%xmm0,temp
	
	mov	temp,%eax
	push	%rax
	
	mov	$returned,%rcx
	call	write_stdout
	pop	%rax
	push	%rax
	call	print_hex
	call	print_lf

	# after

	mov     $after,%rcx
	call    write_stdout
	
	movdqu	%xmm0,output
	
	mov	$output,%rcx
	call	null_change
	call	write_stdout
	call	print_lf
	
	
	pop	%rax

	cmp	$0x54455354,%eax

	jne	fail
	
	
	#########################
	# Test XMM to mem64
	#########################

	movl   $0xdeadbeef,temp	 	# clear out test
	movl   $0xcafebabe,temp+4

	mov    $mem64,%rcx
	call   write_stdout


	# Fill xmm0
	
	mov     $before,%rcx
	call    write_stdout
	
        movdqu  garbage,%xmm0
	movdqu	%xmm0,output
	
	mov	$output,%rcx
	call	null_change
	call	write_stdout
	call	print_lf

	# write 64-bits to xmm0

	mov	$0x5445535445535721,%rax		# testesw!
	push	%rax	
	mov	$expected,%rcx
	call	write_stdout
	pop	%rax
	push	%rax
	call	print_hex
	call	print_lf
	pop	%rax
	
	mov	%rax,temp
	
	rex.w movd	temp,%xmm0
	
	xor	%rax,%rax 			# clear in between
	
	rex.w movd	%xmm0,temp
	
	mov	temp,%rax
	push	%rax
	
	mov	$returned,%rcx
	call	write_stdout
	pop	%rax
	push	%rax
	call	print_hex
	call	print_lf

	# after

	mov     $after,%rcx
	call    write_stdout
	
	movdqu	%xmm0,output
	
	mov	$output,%rcx
	call	null_change
	call	write_stdout
	call	print_lf
	
	
	pop	%rax

	cmp	$0x45535721,%eax
	jne	fail
	
	ror	$32,%rax
	cmp	$0x54455354,%eax
	jne	fail


	#######################
	#
	# if we get here, all went well
	#
	#######################

	mov	$good_string,%rcx
	call	write_stdout	

	jmp	our_exit

fail:	
	call    print_decimal	# print it
	call	print_lf
	mov	$bad_string,%rcx
	call	write_stdout	

	jmp	our_exit

null_change:
	mov     %rcx,%rsi
	mov     %rsi,%rdi
	push    %rcx
				
	mov     $16,%rcx
null_loop:
	lodsb
	cmp     $0,%al
	jnz     not_null
	mov 	$'*',%al
not_null:
	cmp	$0xff,%al
	jnz	just_plain
	mov	$'-',%al
	
just_plain:
        stosb
        loop    null_loop
	 
	pop     %rcx
	ret


our_exit:

	# fall through to exit

.include "../common/library.x86_64"

.data
.balign 16
temp:	  	.quad   0xdeadbeefcafebabe
garbage:	.ascii "0123456789ABCDEF\0"
output:		.ascii "KHBBILTTTAFHITA!\0"
reg32:		.ascii "XMM to Reg32:\n\0"
reg64:		.ascii "XMM to Reg64:\n\0"
mem32:		.ascii "XMM to Mem32:\n\0"
mem64:		.ascii "XMM to Mem64:\n\0"
before:		.ascii "  xmm0 before: \0"
after:		.ascii "  xmm0 after:  \0"
expected:	.ascii "  Expected: \0"
returned:	.ascii "  Returned: \0"
good_string:	.ascii	"Good\n\0"
bad_string:	.ascii	"Fail\n\0"
