
# This tests movhps on x86_64

.include "../common/syscalls.x86_64"

	.globl _start	
_start:	

	# move 1 2 4 8 into xmm2
	
	mov    	      $1,%rax	  	# load 1 into rax
	cvtsi2ss      %rax,%xmm2	# convert to single fp
	pslldq        $4,%xmm2		# shift it up
	
	mov    	      $2,%rax	  	# load 2 into rax
	cvtsi2ss      %rax,%xmm2	# convert to single fp
	pslldq        $4,%xmm2		# shift it up
	
	mov    	      $4,%rax	  	# load 4 into rax
	cvtsi2ss      %rax,%xmm2	# convert to single fp
	pslldq        $4,%xmm2		# shift it up
	
	mov    	      $8,%rax	  	# load 8 into rax
	cvtsi2ss      %rax,%xmm2	# convert to single fp

	########################
	# Test movlps reg -> mem
	########################
	
	movdqa	      %xmm2,%xmm0
	
	mov	      $movlps_rm_label,%rcx
	call	      write_stdout
	
	movlps	      %xmm0,temp	# move xmm0 low to mem

	movd	      %xmm0,%rax
	call	      print_hex
	call	      print_lf

	mov	      temp+8,%eax	# check if we wrote to wrong place
	cmp	      $0xdeadbeef,%eax
	jne	      fail
	
	########################
	# Test movlps mem -> reg
	########################	

	mov	      $movlps_mr_label,%rcx
	call	      write_stdout
	
	xor	      %rax,%rax
	movd	      %rax,%xmm0	
		
	movlps	      temp,%xmm0	# move it back into low	
	movdqa	      %xmm0,%xmm1	
	
	movd	      %xmm1,%rax
	push	      %rax
	call	      print_hex
	call	      print_lf

	pop	      %rax
	cmp	      $0x41000000,%eax
	jne	      fail

	########################
	# Test movhps reg -> mem
	########################

	movdqa	      %xmm2,%xmm0

	mov	      $movhps_rm_label,%rcx
	call	      write_stdout

	movhps	      %xmm0,temp	# move xmm0 low to mem

	mov	      temp,%rax
	call	      print_hex
	call	      print_lf

	mov	      temp+8,%eax	# check if we wrote to wrong place
	cmp	      $0xdeadbeef,%eax
	jne	      fail


	########################
	# Test movhps mem -> reg
	########################	

	mov	      $movhps_mr_label,%rcx
	call	      write_stdout

	xor	      %rax,%rax		# clear
	movd	      %rax,%xmm0	
	movhps	      temp,%xmm0	# move into high
	movdqa	      %xmm0,%xmm1		
	psrldq        $8,%xmm1		# shift it down

	movd	      %xmm1,%rax
	
	push	      %rax
	call	      print_hex
	call	      print_lf

	pop	      %rax
	cmp	      $0x40000000,%eax
	jne	      fail

good:
	mov	      $good_string,%rcx
	call	      write_stdout
	jmp	      our_exit

fail:	
	mov	      $bad_string,%rcx
	call	      write_stdout


our_exit:
	 

	# fall through to exit

.include "../common/library.x86_64"

.data
.balign 16
temp:		.int  1,2,0xdeadbeef,0xcafebabe
temp2:		.int  8,9,10,11

movlps_rm_label: .ascii "Testing movlps reg -> mem : \0"
movlps_mr_label: .ascii "Testing movlps mem -> reg : \0"
movhps_rm_label: .ascii "Testing movhps reg -> mem : \0"
movhps_mr_label: .ascii "Testing movhps mem -> reg : \0"

good_string:	.ascii	"Good\n\0"
bad_string:	.ascii	"Fail\n\0"
