# This tests shrd on x86_64

#
# Some of these tests are *undefined* and give different results
#   on AMD machines versus Intel
#


.include "../common/syscalls.x86_64"

	.globl _start	
_start:	

	mov	$title,%rcx
	call	write_stdout

	#
	# Test shrdq
	# 
	
	mov	$value1,%rcx
	call	write_stdout

	mov	$0xdeadbeefcafebabe,%rax
	mov	$0x0123456789abcdef,%rbx
	
	push	%rax
	push	%rbx

	call	print_hex
	call	print_lf
	
	mov	%rbx,%rax
	
	push	%rax
	
	mov	$value2,%rcx
	call	write_stdout
	
	pop	%rax
	
	call	print_hex
	call	print_lf

	mov	$shift1,%rcx
	call	write_stdout

	pop	%rbx
	pop	%rax
	
	mov	$0x08,%cl
	shrd	%rax,%rbx

	push	%rbx
	
	mov	$value3,%rcx
	call	write_stdout
	
	pop	%rbx

	mov	%rbx,%rax
	
	push	%rax
	
	call	print_hex
	call	print_lf

	mov	$value4,%rcx
	call	write_stdout

	pop	%rax
	
	cmp	$0x6789abcd,%eax
	jne	fail
	
	
	# 
	# Test shrdw
	#

	mov	$shift2,%rcx
	call	write_stdout

	mov	$value3,%rcx
	call	write_stdout

	mov	$0x000000000000babe,%rax
	mov	$0x0123456789abcdef,%rbx
	
	mov	$0x13,%cl
	shrdw	%rax,%rbx

	mov	%rbx,%rax
	
	push	%rax
	
	call	print_hex
	call	print_lf

	mov	$value5,%rcx
	call	write_stdout

	pop	%rax
	
	cmp	$0x89ABD757,%eax
#	jne	fail
	
	# 
	# Test shrdw ax,bx
	#

	mov	$shift3,%rcx
	call	write_stdout

	mov	$value3,%rcx
	call	write_stdout

	mov	$0xdeadbeefcafebabe,%rax
	mov	$0x0123456789abcdef,%rbx
	
	mov	$0x13,%cl
	shrdw	%ax,%bx

	mov	%rbx,%rax
	
	push	%rax
	
	call	print_hex
	call	print_lf

	mov	$value6,%rcx
	call	write_stdout

	pop	%rax
	
	cmp	$0x89ABD757,%eax
#	jne	fail	
	
	
	jmp	our_exit


fail:	
	mov	$bad_string,%rcx
	call	write_stdout	
	jmp	our_exit

our_exit:

	# fall through to exit

.include "../common/library.x86_64"

.data

temp:	.int 0xdeadbeef,0xcafebabe
temp2:	.int 0xfeb1378,0xdec3051

title:	     .ascii "Testing shrd instruction\n\0"
value1:	     .ascii "   setting %rax to : \0"
value2:      .ascii "   setting %rbx to : \0"
shift1:	     .ascii " Shifting: shrd %rax,%bax  , %cl=0x8\n\0"
value3:	     .ascii "  Result in %rbx    : \0" 
value4:	     .ascii "  Should be         : BE0123456789ABCD\n\0"     
shift2:	     .ascii " Shifting: shrdw %rax,%rbx  , %cl=0x13\n\0"
value5:	     .ascii "  Should be         : 0123456789ABD757\n\0"     
shift3:	     .ascii " Shifting: shrdw %ax,%bx  , %cl=0x13\n\0"
value6:	     .ascii "  Should be         : 0123456789ABD757\n\0"     

good_string:	.ascii	"Good\n\0"
bad_string:	.ascii	"Fail\n\0"
